//-----------------------------------------------------------------------------
// Copyright:      RAD Electronic Co. LTD,
// Author:         jaruwit supa, Base on FontEditor written by H. Reddmann
//								 Modified by Sh. Nourbakhsh Rad for Persian and Arabic font
//								 and fixed some errors
// Remarks:        
// known Problems: none
// Version:        1.7.0  01.09.2011
// Description:    Font Library
//-----------------------------------------------------------------------------

#ifndef _FONT_H_
	#define _FONT_H_

	#include <string.h>


// 	#include "Graphic.h"

	/////////////////////////////////////////////////////////
	#define	PROGMEM_read_b(x)					(unsigned char)x		//pgm_read_byte(&x)
	#define	PROGMEM_read_w(x)					(unsigned short)x		//pgm_read_word(&x)

	#define bit_is_one(d, b)	    		(d & (1<<b))				//bit_is_set(d, b)
	
	#define StrnCpy(a, b, c)					strncpy(a, b, c)		//strncpy_P(a, b, c)
	#define StrnLen(a, b)							StrNlen(a, b)				//strnlen_P(a, b)
	/////////////////////////////////////////////////////////
	typedef enum {
		E_LETTER,
	  P_LETTER
	} Lt_Mode;


	/////////////////////////////////////////////////////////
	#define STYLE_NONE								0
	#define STYLE_NO_ZERO   					1
	#define STYLE_NO_SPACE  					2
	
	#define ALINE_LEFT								0
	#define ALINE_CENTER							1
	#define ALINE_RIGHT								2
	#define ALINE_MARK								(ALINE_LEFT | ALINE_CENTER | ALINE_RIGHT)
	
	
	#define BORDER_NONE								0x00
	#define BORDER_RECT								0x04
	#define BORDER_FILL								0x08
	#define BORDER_BEVEL							0xF0	// bevel radius 0x00(rectangle), 0x10-0xF0(radius size)
	#define BORDER_MASK								(BORDER_FILL | BORDER_RECT)
	#define bvl(x)										(x<<4)


	/////////////////////////////////////////////////////////
	size_t StrNlen (const char* s, size_t maxlen);
	
	extern void LcdFont(const unsigned char *pointer);

	extern void LcdRot(unsigned char r);
	extern void LcdReverse(unsigned char rv);
	extern void LcdHorizontal(unsigned char hv);

	extern void LcdFontFixed(unsigned char typ);
	extern void	LcdNonTransparence(unsigned char nt);
	
	extern void	LcdFgColor(unsigned short color);
	extern void	LcdBkColor(unsigned short color);
	
	extern void SetLine(unsigned char line,unsigned char column);

	extern unsigned int CalcTextWidth(char *Text);
	extern unsigned int CalcTextHeight(char *Text);

	extern void PutChar(unsigned char c);
	extern void Puts(char *c);
	extern void PutsP(char *Text);

	extern void PutLong(unsigned long src, unsigned char digit, unsigned char decimal, unsigned char Parameter);
	extern void PutInt(unsigned short src, unsigned char digit, unsigned char decimal, unsigned char Parameter);
	extern void PutByte(unsigned char src, unsigned char digit, unsigned char decimal, unsigned char Parameter);
	
	extern void PutText(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, char *Text, unsigned char aline);
	extern void PutTextP(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, const char *Text, unsigned char aline);
	extern void TextBox(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style);
	extern void TextBoxP(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style);

	//////////////
	extern void SetLetter(Lt_Mode L);
	extern void PutsPE(char *str);

	extern void PutCharPE(unsigned char c);
	extern void PutCharEN(unsigned char c);
	
	extern unsigned int CalcTextWidthEN(char *str);
	extern unsigned int CalcTextWidthPE(char *str);
	
	/////////////////////////////////////////////////////////	
	extern unsigned char 							rot;
	extern unsigned char 							Reverse;
	extern unsigned char							Horizontal;

	extern unsigned short							FgColor;
	extern unsigned short							BkColor;
	extern unsigned char							FontFixed;
	extern unsigned char							NonTransparence;
	
	extern unsigned char 							FontWidth;
	extern unsigned char 							FontHeight;
	extern unsigned char 							FontXScale;
	extern unsigned char 							FontYScale;
	extern unsigned char 							FontSpace;
	
	extern unsigned int 							cursorX;		// x position
	extern unsigned int 							cursorY;		// y position

	extern unsigned char							peLETTER;		//English or Persian letter

	/////////////////////////////////////////////////////////	
	#define GetLetter() 							peLETTER

	#define GetCursorX() 							cursorX
	#define GetCursorY() 							cursorY
	#define SetCursorX(x) 						cursorX = x
	#define SetCursorY(y) 						cursorY = y
	#define SetCursor(x,y) 						{cursorX = x; cursorY = y;}
	
	#define LcdRot(n)									rot = n
	#define LcdReverse(n)							Reverse = n
	#define LcdHorizontal(n)					Horizontal = n
	
	#define LcdFontFixed(n)						FontFixed = n
	#define LcdNonTransparence(n)			NonTransparenz = n
	
	#define SetFgColor(n)							FgColor = n
	#define SetBkColor(n)							BkColor = n
	#define GetFgColor()							FgColor
	#define GetBkColor()							BkColor
	
	#define LcdFontXScale(n)					FontXScale = n
	#define LcdFontYScale(n)					FontYScale = n
	#define LcdFontSpace(n)						FontSpace  = n
	
	#define LcdFontWidth() 	 					FontWidth
	#define LcdFontHeight()						FontHeight
	
	// complex function
	#define DrawStringAt(l,c,s,fk,bk)			SetLine(l,c); SetFgColor(fk); SetBkColor(bk); Puts(s)
	#define DrawStringAtP(l,c,s,fk,bk)		SetLine(l,c); SetFgColor(fk); SetBkColor(bk); PutsP(s)

#endif	//_FONT_H_
