#ifndef __STM32F10x_FUNCTION_H
#define __STM32F10x_FUNCTION_H

#include <stdio.h>
#define SYS_CLK 72
#include "delay.c"

#define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#define led1_on()  GPIO_ResetBits( GPIOC , GPIO_Pin_10 )
#define led1_off() GPIO_SetBits( GPIOC , GPIO_Pin_10 )

//------------------------------------------------------------------//

void rcc_cfg(void);
void init_leds(void);
void qusart_init(void);

//------------------------------------------------------------------//
void rcc_cfg()
{
  ErrorStatus HSEStartUpStatus;
  RCC_DeInit();
  RCC_HSEConfig(RCC_HSE_ON);
  HSEStartUpStatus = RCC_WaitForHSEStartUp();
  if(HSEStartUpStatus == SUCCESS)
  {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
    FLASH_SetLatency(FLASH_Latency_2);
    RCC_HCLKConfig(RCC_SYSCLK_Div1); 
    RCC_PCLK2Config(RCC_HCLK_Div1); 
    RCC_PCLK1Config(RCC_HCLK_Div2);
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);
    RCC_PLLCmd(ENABLE);
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
    while(RCC_GetSYSCLKSource() != 0x08);
  }

}
//------------------------------------------------------------------//
void leds_init()
{  
  GPIO_InitTypeDef  GPIO_InitC;
  RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOC , ENABLE);

  GPIO_InitC.GPIO_Pin = GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12;
  GPIO_InitC.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitC.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOC, &GPIO_InitC);
  GPIO_SetBits( GPIOC , GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 );
}
//------------------------------------------------------------------//
void qusart_init()
{
  USART_InitTypeDef uart;
  GPIO_InitTypeDef GPIO_InitStructure;

  RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1 , ENABLE);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

//  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
//  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
//  GPIO_Init(GPIOA, &GPIO_InitStructure);
  
  uart.USART_BaudRate = 115200;
  uart.USART_WordLength = USART_WordLength_8b;
  uart.USART_StopBits = USART_StopBits_1;
  uart.USART_Parity = USART_Parity_No ;
  uart.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  uart.USART_Mode = USART_Mode_Tx ;//| USART_Mode_Rx;
  USART_Init(USART1, &uart);
  USART_Cmd(USART1, ENABLE);     
}
//------------------------------------------------------------------//
PUTCHAR_PROTOTYPE
{
  USART_SendData(USART1, (u8) ch);
  while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
  return ch;
}
//------------------------------------------------------------------//
#endif
