/*															          *
**	     ILI9325 8 Bit Interface Driver						          *
**																      *
**		 Porting to STM32F10xx by Saeed Sharifian				      *
**		 Apr 2012  Ver 1.00										      *
**																      *
***********************************************************************/
#include "stm32f4xx.h"
#include "ili9325.h"
#include "font8x16-2.h"

uint16_t x_text2=0, y_text2=0;

////////////////////////////////////////////////////////////////////////
int 												LCD_margin_xl 		= 0;
int 												LCD_margin_xr 		= MaxX  - 1;
int 												LCD_margin_yu 		= 0;
int 												LCD_margin_yl 		= MaxY  - 1;

unsigned int 								newX							= 0;
unsigned int 								newY							= 0;
//**********************************************************************

//**********************************************************************
void tft_Gotoxy(uint16_t x, uint16_t y)
{
#ifdef PORTRAIT
  if(x>29 || y>19) 
  {
    y+=x/29;
    x%=29;
  }
#endif
#ifdef LANDSCAPE
  if(x>39 || y>14) 
  {
    y+=x/39;
    x%=39;
  }
#endif
  x_text2=x;
  y_text2=y;
}
//**********************************************************************
void tft_Putc(char character, uint32_t frg, uint32_t bkg)
{  
  int8_t wcount, hcount;
  char char_data;

  tftlcd_setArea(x_text2*8, y_text2*16, (x_text2*8)+7, (y_text2*16)+15);
  tftlcd_writeIndex(0x22);
  for(hcount=0; hcount<16; hcount++)
  {
    char_data = font8x162[character-0x20][hcount];
   
   	for(wcount=7; wcount>-1; wcount--)
	{
      if ((char_data&(1<<wcount))>>wcount)
	    tftlcd_writeData(frg);
	  else
	    tftlcd_writeData(bkg);
	}
  }
#ifdef PORTRAIT
  if(++x_text2>29)
  {            
    x_text2=0;
    if(++y_text2>19) y_text2=0;
  }
#endif
#ifdef LANDSCAPE
  if(++x_text2>39)
  {            
    x_text2=0;
    if(++y_text2>14) y_text2=0;
  }
#endif
}
//**********************************************************************
void tft_Puts(char *string, uint32_t frg, uint32_t bkg)
{
  while(*string)
  tft_Putc(*string++, frg, bkg);
}
//**********************************************************************
//**********************************************************************


