#ifndef __ILI9325_H__
#define __ILI9325_H__

#include "stm32f4xx.h"

#define PORTRAIT
//#define LANDSCAPE

/* --------------------------------------------------------------------------- */
#define LCD_DataPort		GPIOB
#define LCD_CS(bit)			GPIO_WriteBit(GPIOC, GPIO_Pin_3, (BitAction)bit)
#define LCD_RS(bit)			GPIO_WriteBit(GPIOC, GPIO_Pin_2, (BitAction)bit)
#define LCD_WR(bit)			GPIO_WriteBit(GPIOC, GPIO_Pin_1, (BitAction)bit)
#define LCD_RD(bit)			GPIO_WriteBit(GPIOC, GPIO_Pin_0, (BitAction)bit)
#define LCD_Reset(bit)		GPIO_WriteBit(GPIOA, GPIO_Pin_2, (BitAction)bit)
#define LCD_Backlight(bit)	GPIO_WriteBit(GPIOA, GPIO_Pin_1, (BitAction)bit)
/* --------------------------------------------------------------------------- */

/* --------------------------------------------------------------------------- */
#ifdef PORTRAIT
#define MaxX				239
#define MaxY				319
#endif

#ifdef LANDSCAPE
#define MaxX				319
#define MaxY				239
#endif
/* --------------------------------------------------------------------------- */

/* Custom RGB Pallete definitions */
#define  BLACK        0x0000
#define  NAVY         0x000F
#define  BLUE         0x001F
#define  DGREEN       0x03E0
#define  GREEN        0x07E0
#define  RED          0xF800
#define  LRED         0xF9E7
#define  DCYAN        0x03EF
#define  CYAN         0x07FF
#define  LCYAN        0x0410
#define  MAGENTA      0xF81F
#define  VIOLET		  0x70FF
#define  PURPLE       0x780F
#define  OLIVE        0x7BE0
#define  MAROON       0x7800 
#define  YELLOW       0xFFE0
#define  LYELLOW      0xEEF0
#define  GOLD         0xF5E0
#define  ORANGE       0xFC60
#define  LGREY        0xC618
#define  GREY         0x7BEF
#define  WHITE        0xFFFF

/* --------------------------------------------------------------------------- */
void tftlcd_writeIndex(uint16_t cmd);
void tftlcd_writeData(uint16_t data);
//uint16_t tftlcd_readIndex(uint16_t cmd);
//uint16_t tftlcd_readData(void);
static __inline void tftlcd_writeReg(uint16_t cmd, uint16_t data);
//static __inline uint16_t tftlcd_readReg(uint16_t cmd);

void tftlcd_init(void);
void tftlcd_setArea(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2);
void tftlcd_gotoxy(uint16_t x, uint16_t y);
void tftlcd_setCursor(uint16_t xPos, uint16_t yPos);
void tftlcd_clearScreen(uint32_t bkgColor);

void tftlcd_backlightOn(void);
void tftlcd_backlightOff(void);

void tftlcd_line(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t color);
void tftlcd_rect(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1, uint16_t color, uint8_t fill);
void tftlcd_circle(uint16_t cx, uint16_t cy, uint16_t rad, uint16_t color, uint8_t fill);
void tftlcd_putPixel(uint16_t x, uint16_t y, uint16_t color);
uint16_t tftlcd_getPixel(uint16_t x, uint16_t y);

void tftlcd_putChr(char character, uint16_t frgColor, uint16_t bkgColor);
void tftlcd_putStr(char *string, uint16_t frgColor, uint16_t bkgColor);

void tftlcd_showBitmap16Bit(uint16_t x, uint16_t y, uint16_t xSize, uint16_t ySize, const uint16_t *bmp_array);
void tftlcd_showBitmap8Bit(uint16_t x, uint16_t y, uint16_t xSize, uint16_t ySize, const uint8_t *bmp_array);

void tftlcd_test(void);

/* --------------------------------------------------------------------------- */

#endif /* __ILI9325_H__ */

